﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ProgUstredni
{
    public class Raketa
    {
        public float X, Y;
        public float Vx, Vy;
        public float Palivo;
        public float L, R, W;

        private string hostname;
        public int id = -1;
        private bool running = false;

        public bool Nahoru = false, Doleva = false, Doprava = false;
        public bool konec = false;
        public bool zdar = false;

        public Raketa(string hostname)
        {
            this.hostname = hostname;
        }

        public string Start()
        {
            if (!running)
            {
                running = true;
                string stav = Http.Get("http://" + hostname + "/start");
                this.setStav(stav);

                return stav;
            }
            else throw new Exception("Already started");
        }

        public string Update()
        {
            if (running)
            {
                string stav = Http.Get(
                        "http://" + this.hostname + "/stav?id=" + this.id +
                        "&nahoru=" + (this.Nahoru ? 1 : 0) +
                        "&doleva=" + (this.Doleva ? 1 : 0) +
                        "&doprava=" + (this.Doprava ? 1 : 0)
                    );
                this.setStav(stav);

                return stav;
            }
            else throw new Exception("Not started yet");
        }

        private void setStav(string stav)
        {
            if (stav == "Krach!")
            {
                this.konec = true;
                this.zdar = false;
                return;
            }
            if (stav == "Zdar!")
            {
                this.konec = true;
                this.zdar = true;
                return;
            }

            string[] lines = stav.Replace("\r", "").Split('\n');

            int id = int.Parse(lines[0]);

            if (this.id == -1)
            {
                this.id = id;

                this.L = float.Parse(lines[4].Split(' ')[0].Replace('.', ','));
                this.R = float.Parse(lines[4].Split(' ')[1].Replace('.', ','));
                this.W = this.R - this.L;
            }
            if (this.id == id)
            {
                this.X = float.Parse(lines[1].Split(' ')[0].Replace('.', ','));
                this.Y = float.Parse(lines[1].Split(' ')[1].Replace('.', ','));

                this.Vx = float.Parse(lines[2].Split(' ')[0].Replace('.', ','));
                this.Vy = float.Parse(lines[2].Split(' ')[1].Replace('.', ','));

                this.Palivo = float.Parse(lines[3].Replace('.', ','));
            }
        }
    }
}
