﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ProgUstredni
{
    public struct Vector2
    {
        public double X, Y;
        public Vector2(double x, double y)
        {
            X = x;
            Y = y;
        }

        public Vector2(byte direction)
        {
            this.X = 0;
            this.Y = 0;

            switch (direction)
            {
                case 0:
                    this.Y = -1;
                    break;
                case 1:
                    this.X = -1;
                    break;
                case 2:
                    this.Y = 1;
                    break;
                case 3:
                    this.X = 1;
                    break;

                default:
                    throw new Exception("Direction out of bounds");
            }
        }

        public override string ToString()
        {
            return "X: " + this.X + ", Y: " + this.Y;
        }

        public static Vector2 operator +(Vector2 v1, Vector2 v2)
        {
            return new Vector2(v1.X + v2.X, v1.Y + v2.Y);
        }
        public static Vector2 operator -(Vector2 v1, Vector2 v2)
        {
            return new Vector2(v1.X - v2.X, v1.Y - v2.Y);
        }
        public static Vector2 operator *(Vector2 v1, Vector2 v2)
        {
            return new Vector2(v1.X * v2.X, v1.Y * v2.Y);
        }
        public static Vector2 operator *(Vector2 v, double d)
        {
            return new Vector2(v.X * d, v.Y * d);
        }
    }
}
