﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using ProgUstredni;

namespace RaketaAuto
{
    public class Pilot
    {
        Raketa raketa;
        bool brzdeniX = false, brzdeniY = false;
        float maxVx = 50;
        float maxVy = 300;

        public Pilot(Raketa raketa, float max_speed)
        {
            this.raketa = raketa;
            if (max_speed > 0)
                maxVx = maxVy = max_speed;
        }

        private void doleva()
        {
            raketa.Doleva = true;
        }
        private void doprava()
        {
            raketa.Doprava = true;
        }
        void nahoru()
        {
            raketa.Nahoru = true;
        }

        float brzdeni(float x)
        {
            return 0.21f - 0.003f * Math.Abs(x);
        }

        public void Update()
        {
            raketa.Nahoru = false;
            raketa.Doprava = false;
            raketa.Doleva = false;

            // brzdná dráha roste ~ s kvardátem rychlosti
            if (raketa.Y < brzdeni(raketa.Vy) * raketa.Vy * raketa.Vy)
            {
                brzdeniY = true;
            }

            if (!brzdeniX)
            {
                // pokud jsme nad plochou, tak prejdeme do stage brzdeni
                if (raketa.L < raketa.X && raketa.X < raketa.R && Math.Abs(raketa.Vx) < 0.5)
                    brzdeniX = true;

                float deltaX = (raketa.L + raketa.R) / 2 - raketa.X;

                // zrychlime pozadovnym smerem na ~maxVx
                if (Math.Abs(raketa.Vx) < maxVx - 1)
                {
                    if (deltaX > 0)
                        doprava();
                    else
                        doleva();
                }

                if (deltaX > 0 && deltaX < 0.128 * raketa.Vx * raketa.Vx)
                    brzdeniX = true;
                if (deltaX < 0 && -deltaX < 0.128 * raketa.Vx * raketa.Vx)
                    brzdeniX = true;
            }

            if (Math.Abs(raketa.Vy) + 1 > maxVy)
                nahoru();

            if (brzdeniY)
            {
                if (raketa.Vy < -4) nahoru();
            }

            if (brzdeniX)
            {
                if (Math.Abs(raketa.Vx) > 0.5)
                {
                    if (raketa.Vx > 0)
                        doleva();
                    else
                        doprava();
                }
            }
        }
    }
}
