﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgUstredni;
using System.Threading;

namespace RaketaAuto
{
    class Program
    {
        static void Main(string[] args)
        {
            string hostname = "127.0.0.1:8000";
            float max_speed = -1;

            if (args.Length > 0)
                hostname = args[0];
            if (args.Length > 1)
                max_speed = float.Parse(args[1].Replace('.', ','));

            Raketa raketa = new Raketa(hostname);
            Pilot pilot = new Pilot(raketa, max_speed);

            Console.WriteLine("Vizualizace mozna pres RaketaRucne.exe\n - pred adresu napiste 'autopilot ' <-(mezera)");
            Console.WriteLine("Pripojuji...");

            try
            {
                raketa.Start();
            }
            catch (Exception e)
            {
                Console.WriteLine("Selhalo");
                Console.ReadLine();
                return;
            }

            Console.WriteLine("Pripojeni id {0}", raketa.id);

            while (true)
            {
                pilot.Update();
                raketa.Update();

                if (raketa.konec)
                    break;

                Thread.Sleep(50);
            }

            Console.WriteLine(raketa.zdar ? "Zdar!" : "Krach!");
            Console.ReadLine();
        }
    }
}
